%define kdeprefix /opt/kde
%define version 1.1.1
%define kderelease 2
%define sourcedir stable/1.1.1/distribution/tar/generic/source
%define tag -1.1.1
%define topdirtag -1.1.1
Serial: 3

%define target RedHat 5.1 or 5.2 systems
%define compiler egcs
%define rhseries rh5x
%define redhat redhat-release >= 5.1
%define qtrequired  qt >= 1.42 qt-egcs-10x

%define kdename kdebase
%define topdir %{kdename}%{topdirtag}
%define pamservice kde
Name: %{kdename}
Summary: K Desktop Environment - core files
Version: %{version}
Release: %{kderelease}%{rhseries}
URL: http://www.kde.org
Source: ftp://ftp.kde.org:/pub/kde/{sourcedir}/%{kdename}%{tag}.tar.gz
Source1: redhat-logo.xpm
Source2: kde.pamd
Patch: kdebase-%{version}-redhat.patch
Patch1: kdebase-1.1.1-ftp.patch
Patch2: kdebase-1.1.1-kvt.patch
Group: X11/KDE/Base
Copyright: GPL/Artistic
BuildRoot: /var/tmp/%{kdename}-buildroot
Provides: kdebase-%{rhseries}
Requires: pam %{qtrequired} %{redhat} kdesupport-%{rhseries} kdelibs-%{rhseries} 
Distribution: KDE
Packager: KDE Packaging Team <redhat-rpms@kde.org>
Vendor: The KDE Team
Prefix: %{kdeprefix}
Prereq: /usr/X11R6/bin/mkfontdir

%description
Core applications for the K Desktop Environment.
Included are:  kdm (replacement for xdm), kwm (window manager), kfm 
(filemanager, web browser, ftp client, ...), konsole (xterm replacement), 
kpanel (application starter and desktop pager), kaudio (audio server), 
kdehelp (viewer for kde help files, info and man pages), plus other KDE 
components (kcheckpass, kikbd, kvt, kscreensaver, kcontrol, kfind, 
kfontmanager, kmenuedit, kappfinder).

This package is intended for %{target}.
It supports RedHat's PAM password authentication (PAM service: %{pamservice}).
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."
 
%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %{topdir}

#patch to set redhat defaults in kdm
%patch -p1
# bugfix patch to fix ftp uploads in kfm
%patch1 -p1
# kvt security patch
%patch2 -p1

%build
export KDEDIR=%{kdeprefix}
CC=%{compiler} ./configure  --prefix=%{kdeprefix} --with-pam=%{pamservice}  --with-install-root=$RPM_BUILD_ROOT  --without-gl

make

%install
make prefix=$RPM_BUILD_ROOT%{kdeprefix} RUN_KAPPFINDER=no install-strip

#install sample PAM configuration file
install -d $RPM_BUILD_ROOT%{kdeprefix}/etc/pam.d
install -m 644 $RPM_SOURCE_DIR/kde.pamd \
	$RPM_BUILD_ROOT%{kdeprefix}/etc/pam.d/%{pamservice}

# remove unsupported control center information services
#cd $RPM_BUILD_ROOT%{kdeprefix}/share/applnk/Settings/Information
#rm -f partitions.kdelnk

# install redhat-logo icon for kdm
install -m 644 $RPM_SOURCE_DIR/redhat-logo.xpm \
	$RPM_BUILD_ROOT%{kdeprefix}/share/apps/kdm/pics/redhat-logo.xpm
cd $RPM_BUILD_ROOT%{kdeprefix}/share/config
mv -f kdmrc kdmrc.temp
sed -e 's^KDEDIR^%{kdeprefix}^g' kdmrc.temp > kdmrc
rm -f kdmrc.temp

# install linux console fonts
install -d $RPM_BUILD_ROOT%{kdeprefix}/X11R6/fonts
for file in $RPM_BUILD_DIR/%{topdir}/konsole/other/linux*.pcf.gz ; do
	install -m 644 $file $RPM_BUILD_ROOT%{kdeprefix}/X11R6/fonts
done


cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
	$RPM_BUILD_DIR/file.list.%{kdename}

find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
	-e '/\/config\//s|^|%config|' >> \
	$RPM_BUILD_DIR/file.list.%{kdename}

find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
	$RPM_BUILD_DIR/file.list.%{kdename}


# fix suid root bit on kvt and konsole_grantpty
cat $RPM_BUILD_DIR/file.list.%{kdename} > $RPM_BUILD_DIR/temp
sed -e '/\/bin\/kvt$/s/attr(-/attr(4755/' -e '/\/bin\/konsole_grantpty$/s/attr(-/attr(4755/' $RPM_BUILD_DIR/temp > $RPM_BUILD_DIR/file.list.%{kdename} 
rm -f $RPM_BUILD_DIR/temp


%post
# configure kdmrc to make the redhat logo the kdm logo
if ! [ "%{kdeprefix}" = "$RPM_INSTALL_PREFIX" ] ; then
	mv -f $RPM_INSTALL_PREFIX/share/config/kdmrc $RPM_INSTALL_PREFIX/share/config/kdmrc.tmp
	grep -v "LogoPixmap" $RPM_INSTALL_PREFIX/share/config/kdmrc.tmp > $RPM_INSTALL_PREFIX/share/config/kdmrc
	echo  "LogoPixmap=$RPM_INSTALL_PREFIX/share/apps/kdm/pics/redhat-logo.xpm" >> $RPM_INSTALL_PREFIX/share/config/kdmrc
	rm -f $RPM_INSTALL_PREFIX/share/config/kdmrc.tmp
fi

# configure the pam service if necessary
if ! [ -d /etc/pam.d ] ; then
	install -d /etc/pam.d
fi
if ! [ -f /etc/pam.d/%{pamservice} ] ; then
        install -m 644 $RPM_INSTALL_PREFIX/etc/pam.d/%{pamservice} /etc/pam.d/%{pamservice}
fi

# add the linux fonts for the console
cp $RPM_INSTALL_PREFIX/X11R6/fonts/linux*.pcf.gz /usr/X11R6/lib/X11/fonts/misc
/usr/X11R6/bin/mkfontdir /usr/X11R6/lib/X11/fonts/misc


%preun
if [ "$1" = "0" ] ; then
  if [ -f  /etc/pam.d/%{pamservice} ] ; then	
    if diff $RPM_INSTALL_PREFIX/etc/pam.d/%{pamservice} /etc/pam.d/%{pamservice} > /dev/null ; then
      rm -f /etc/pam.d/%{pamservice}
    else
      mv -f /etc/pam.d/%{pamservice} /etc/pam.d/%{pamservice}.rpmsave
    fi
  fi
fi


%postun
# remove the linux fonts added for the console
rm -f /usr/X11R6/lib/X11/fonts/misc/linux*.pcf.gz 
/usr/X11R6/bin/mkfontdir /usr/X11R6/lib/X11/fonts/misc



%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{kdename}

%files -f ../file.list.%{kdename} 



%changelog
* Thu Jun 10 1999 <duncan@kde.org>
- apply kvt security fix patch

* Sun May 30 1999 <duncan@kde.org>
- patch to fix ftp upload bug

* Sat May 1 1999 <duncan@kde.org>
- updated for KDE-1.1.1
- install linux console fonts for konsole.

* Fri Feb 26 1999 <duncan@kde.org>
- fix kvt so it is suid root for chown'ing the tty and has utmp support

* Mon Feb 16 1999 <duncan@kde.org>
- fix to %post for cdrom installs.

* Sat Feb 13 1999 <duncan@kde.org>
- files in KDEDIR/share/applnk no longer treated as %config files

* Wed Feb 10 1999 <duncan@kde.org> 
- post-release bugfix patch: to krootwm/krootwm.C from <faure@kde.org> 

* Mon Feb 8 1999 <duncan@kde.org>
- new rpm packaging for KDE-1.1
- relocatable rpms





